#pragma once
#include "Entity.h"
#include "EntityState.h"
#include "EntityStateFlashEffect.h"
#include "EntityStateInvincible.h"
#include "CS_QuoteGravity.h"
#include "CS_PuppyFishWater.h"
#include "CS_PuppyFishControl.h"
#include "CS_PuppyFishResist.h"
#include "CS_PuppyFishJump.h"
#include "CS_PuppyFishStand.h"
#include "CS_PuppyFishSwim.h"
#include "CS_PuppyFishFaceToBack.h"
#include "CS_PuppyFishHurt.h"
#include "CS_PuppyFishBubbleBeam.h"
#define CS_PUPPYFISH_CREATENAME L"CS_mychar_puppyfish"
//玩家角色 小狗（鱼的形态）
class CS_PuppyFish :
    public MyCharEntity
{
public:
    CS_PuppyFish();
	void Init(std::weak_ptr<Entity> self) override;
	void Step() override;
	void SetState(int stateID, int lr) override;
	void SetState(std::wstring stateName, int lr) override;
	void LoadSaveData() override;//加载保存数据
	void WriteSaveData() override;//写入保存数据
	bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
	void Gain(std::weak_ptr<Entity> item) override;
	void Destroy() override;
	void GetIcon(std::wstring& png, std::wstring& sprite_index, int& image_index, std::set<int>& hideLayerList) override;
	void CrushDeath();
	void CopyFrom(std::shared_ptr<Entity>& another) override;//让自己获得另一个和自己同类型实体一模一样的属性
	void CheckResetFollowTarget();
	void ResetFollowTarget();
	//图层显示
	float animation_moveSpeed = 0x200 / ts;
	bool animation_delay = false;//走路动画延迟一帧（对齐到整格）
	float floatSrcX = 0;//悬浮位置
	float floatSrcY = 0;
	bool bSetTarget = false;
	std::weak_ptr<Entity> animation_target;
	//状态模块
	EntityStateFlashEffect stateFlash;
	EntityStateInvincible stateInvincible;
	CS_QuoteGravity stateGravity;
	CS_PuppyFishWater stateWater;
	CS_PuppyFishControl stateControl;
	CS_PuppyFishResist stateResist;
	CS_PuppyFishJump stateJump;
	CS_PuppyFishStand stateStand;
	CS_PuppyFishSwim stateSwim;
	CS_PuppyFishFaceToBack stateFaceToBack;
	CS_PuppyFishHurt stateHurt;
	//技能模块
	CS_PuppyFishBubbleBeam skillBubbleBeam;
	//其他变量
	std::wstring crushEvent;
};

std::shared_ptr<Entity> CreateCS_PuppyFish();